#!/bin/sh

#
#     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
#     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
#     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
#     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
#     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
#     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
#     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
#     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
#     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
#     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
#     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
#     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#     FOR A PARTICULAR PURPOSE.
#     
#     (c) Copyright 2004 Xilinx, Inc.
#     All rights reserved.
#

cc_dir=$CORECONNECT

if test "x$CORECONNECT" = "x"
then
    echo 'ERROR: CORECONNECT does not exist (or is not set)'
    echo 'Please set your CORECONNECT environment variable to your'
    echo 'CoreConnect install directory'
    exit 1
fi

if test ! -d $cc_dir
then
    echo "ERROR: $cc_dir does not exist or is not a directory"
    echo 'Please set your CORECONNECT environment variable to your'
    echo 'CoreConnect install directory'
    exit 1
fi

BFC_SIM=verilog
OPB_DCL=$CORECONNECT/tk/TOOLKIT_DCL/
PLB_DCL=$CORECONNECT/tk/TOOLKIT_DCL/
DCR_DCL=$CORECONNECT/tk/TOOLKIT_DCL/

export BFC_SIM
export OPB_DCL
export PLB_DCL
export DCR_DCL

cd ../../data/bfl

xilperl $CORECONNECT/tk/BFC/BFC test_system.bfl test_iic.bfl test_uart16450.bfl test_uart16550.bfl test_sysace.bfl test_enet.bfl test_tft.bfl test_ac97.bfl test_ps2.bfl test_spi.bfl test_tsd.bfl test_par_port.bfl test_ddr.bfl test_pci.bfl test_end.bfl

