/*-----------------------------------------------------------------
 * Tool vhdlToVerilog Version 4.09 
 * Src          File = plb_dcl.vhd 
 * Destination  File = vhdl2Vl/plb_dcl.inc Created Thu Aug 15 13:41:52 2002
 *-----------------------------------------------------------------*/
//------------------------------------------------------------------------------
// Copyright (c) 1998-2002 IBM Microelectronics. All rights reserved          --
//                                                                            --
// Version 4.4
//                                                                            --
// PLB Component Declarations                                                 --
//                                                                            --
// maintained by: IBM Microelectronics                                        --
//                PowerPC Embedded Processor Solutions                        --
//                                                                            --
// support by:                                                                --
//              IBM Microcontroller Applications Group                        --
//              mailto:ppcsupp@us.ibm.com                                     --
//              http://www.chips.ibm.com/products/powerpc/                    --
//              FAX: +1 919 543 7575                                          --
//                                                                            --
//------------------------------------------------------------------------------


`define true  1'b1
`define false 1'b0
`define plb_architecture_version  3 
`define plb_busy_cycle_max  100 
//----------------------------------------------------------------------------
// Constant for the Maximum supported PLB data bus width.                   --
// This parameter should equal the Data Width of largest PLB device in the  --
// simulation model.                                                        --
//----------------------------------------------------------------------------
`define plb_data_bus_width  64 
// valid values: 64 or 128
`define plb_be_bus_width (`plb_data_bus_width / 8 )
`define plb_read_pipeline_depth  4 
// max number of PLB outstanding READ/WRITE transactions (n-1 secondaries)
`define plb_write_pipeline_depth  2 
// max number of PLB outstanding READ/WRITE transactions (n-1 secondaries)
//----------------------------------------------------------------------------
// User Defined Constants for PLB Toolkit                                   --
//----------------------------------------------------------------------------
`define plb_cycle_message_enable 1'b0 
`define plb_memory_mode  0 
// 0 = linear search, fully associative look-up mode
// 1 = direct map cache mode
`define plb_master_mem_size  65536 
// master memory size in bytes (must be divisible by 32)
`define plb_slave_mem_size  65536 
// slave memory size in bytes (must be divisible by 32)
`define plb_master_cmd_array_size  1024 
// number of master bus cycle commands
`define plb_monitor_cmd_array_size  1024 
// number of monitor bus cycle commands
`define plb_monitor_record_array_size  16 
// number of transactions to record
`define plb_monitor_record_synch_array_size  8 
// number of transactions to record
`define plb_slave_cmd_array_size  1024 
// number of slave read/write response commands
`define plb_slave_check_array_size  1024 
// number of slave memory check commands
`define plb_slave_merr_array_size  256 
// number of slave merr commands
`define plb_m_device_max  8 
// max number of PLB master device instantiations
`define plb_s_device_max  8 
// max number of PLB slave device instantiations
`define plb_slave_default_miss_data 32'b00000000000000000000000000000000
`define plb_master_unit_delay 2 
`define plb_slave_unit_delay 2 
//----------------------------------------------------------------------------
// User Updated Constants for PLB Toolkit, based on above settings          --
// (note:done for translation since Verilog doesn't support variable index) --
//----------------------------------------------------------------------------
`define plb_master_tag_left_index  0 
// 0
`define plb_master_tag_right_index  47 
// PLB_MASTER_SET_LEFT_INDEX - 1;
`define plb_master_set_left_index  48 
// PLB_MASTER_SET_RIGHT_INDEX - log2(PLB_MASTER_MEM_SIZE/(PLB_MEM_BUS_WIDTH/8)) + 1;
`define plb_master_set_right_index  59 
// 63 - log2(PLB_MEM_BUS_WIDTH/8);
`define plb_slave_tag_left_index  0 
// 0;
`define plb_slave_tag_right_index  47 
// PLB_SLAVE_SET_LEFT_INDEX - 1;
`define plb_slave_set_left_index  48 
// PLB_SLAVE_SET_RIGHT_INDEX - log2(PLB_SLAVE_MEM_SIZE/(PLB_MEM_BUS_WIDTH/8)) + 1;
`define plb_slave_set_right_index  59 
// 63 - log2(PLB_MEM_BUS_WIDTH/8);
`define plb_complex_q_max  4 
// internal complex transaction queue depth
`define plb_monitor_q_max  4 
// internal monitor transaction queue depth
`define plb_slave_buffer_q_max  128 
// internal write buffer depth, for writes posted during reads
`define plb_slave_q_max  7 
// internal slave cycle q depth
`define plb_master_q_max  150 
// internal master cycle q depth
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
// Toolkit Constants and Type Declarations : Do Not Change ANYTHING below this line!  --
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
`define plb_mem_bus_width  128 
// internal model memory width
`define plb_master_mem_array_size (`plb_master_mem_size /(`plb_mem_bus_width / 8 ))
// master memory array size
`define plb_slave_mem_array_size (`plb_slave_mem_size /(`plb_mem_bus_width / 8 ))
// slave memory array size
`define synch_out_devices ((`plb_m_device_max  + `plb_s_device_max ) +  1 )
`define plb_slave_cmd_width  64 
// --------------------------------------------------------------------------------------
// Signals from all masters to PLB.
//
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
// Signals from PLB to all masters.
//
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
// PLB signals.
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
// Signals from all slaves to PLB.
//
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
// Or'ed signal inputs to PLB macro from slaves
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
// Signals from all masters to PLB.
//
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
// Signals from PLB to all masters.
//
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
// PLB signals.
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
// Signals from all slaves to PLB.
//
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
// Or'ed signal inputs to PLB macro from slaves
// --------------------------------------------------------------------------------------
//-- --------------------------------------------------------------------------------------
//-- Signals from all masters to PLB.
//--
//-- --------------------------------------------------------------------------------------
//-- --------------------------------------------------------------------------------------
//-- Signals from PLB to all masters.
//--
//-- --------------------------------------------------------------------------------------
//-- --------------------------------------------------------------------------------------
//-- PLB signals.
//-- --------------------------------------------------------------------------------------
//-- --------------------------------------------------------------------------------------
//-- Signals from all slaves to PLB.
//--
//-- --------------------------------------------------------------------------------------
//-- --------------------------------------------------------------------------------------
//-- Or'ed signal inputs to PLB macro from slaves
//-- --------------------------------------------------------------------------------------
