//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
// 
// This File is a place holder for the PLB Toolkit - Master

module plb_master3x (
synch_out,
synch_in,
plb_master_error,
plb_clk,
plb_reset,
plb_maddrack,
plb_mssize,
plb_mrearbitrate,
plb_mbusy,
plb_merr,
plb_mwrdack,
plb_mrddbus,
plb_mrdwdaddr,
plb_mrddack,
plb_mrdbterm,
plb_mwrbterm,
m_request,
m_priority,
m_buslock,
m_rnw,
m_be,
m_msize,
m_size,
m_type,
m_compress,
m_guarded,
m_ordered,
m_lockerr,
m_abort,
m_uabus,
m_abus,
m_wrdbus,
m_wrburst,
m_rdburst
);

`include "plb_dcl3x.inc"

parameter plb_master_size = 1;
parameter plb_master_num = 1;
parameter plb_master_addr_lo_0 = 1;
parameter plb_master_addr_hi_0 = 1;
parameter plb_master_addr_lo_1 = 1;
parameter plb_master_addr_hi_1 = 1;

input [0:31] synch_in;
input plb_clk;
input plb_reset;
input plb_maddrack;
input [0:1] plb_mssize;
input plb_mrearbitrate;
input plb_mbusy;
input plb_merr;
input plb_mwrdack;
input [0:(`plb_data_bus_width-1)] plb_mrddbus;
input [0:3] plb_mrdwdaddr;
input plb_mrddack;
input plb_mrdbterm;
input plb_mwrbterm;
output [0:31] synch_out;
output plb_master_error;
output m_request;
output [0:1] m_priority;
output m_buslock;
output m_rnw;
output [0:((`plb_data_bus_width/8)-1)] m_be;
output [0:1] m_msize;
output [0:3] m_size;
output [0:2] m_type;
output m_compress;
output m_guarded;
output m_ordered;
output m_lockerr;
output m_abort;
output [0:31] m_uabus;
output [0:31] m_abus;
output [0:(`plb_data_bus_width-1)] m_wrdbus;
output m_wrburst;
output m_rdburst;

assign synch_out = 32'b0;
assign plb_master_error = 1'b0;
assign m_request = 1'b0;
assign m_priority = 2'b0;
assign m_buslock = 1'b0;
assign m_rnw = 1'b0;
assign m_be = 0;
assign m_msize = 2'b0;
assign m_size = 4'b0;
assign m_type = 3'b0;
assign m_compress = 1'b0;
assign m_guarded = 1'b0;
assign m_ordered = 1'b0;
assign m_lockerr = 1'b0;
assign m_abort = 1'b0;
assign m_uabus = 32'b0;
assign m_abus = 32'b0;
assign m_wrdbus = 0;
assign m_wrburst = 1'b0;
assign m_rdburst = 1'b0;

initial begin
  $display ("Note:  The plb_master3x.v file is provided as a placeholder for an element of ");
  $display ("       the IBM(R) CoreConnect(TM) Toolkit.  The CoreConnect Toolkit is only ");
  $display ("       available to CoreConnect licensees.  Xilinx has simplified the process ");
  $display ("       of becoming a CoreConnect licensee through a web based registration ");
  $display ("       that is available at: ");
  $display ("");
  $display ("       http://www.xilinx.com/coreconnect ");
  $display ("");
  $display ("       CoreConnect licensees are entitled to full access to the CoreConnect ");
  $display ("       Toolkit including powerful bus functional modeling, bus monitoring ");
  $display ("       tools and periodic updates.  To get the most out of the ");
  $display ("       Development Kit, Xilinx recommends the use of the IBM CoreConnect ");
  $display ("       Toolkit. ");
  $display ("");
end

endmodule
