#     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
#     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
#     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
#     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
#     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
#     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
#     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
#     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
#     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
#     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
#     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
#     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#     FOR A PARTICULAR PURPOSE.
#     
#     (c) Copyright 2004 Xilinx, Inc.
#     All rights reserved.

#uses "xillib.tcl"

proc generate {drv_handle} {
    set level [xget_value $drv_handle "PARAMETER" "level"]
    if {$level == 0} {
	# Open include file
	set file_handle [xopen_include_file "xparameters.h"]	
	# Get all peripherals connected to this driver
	set periphs [xget_periphs $drv_handle] 
	# Define NUM_INSTANCES
	set arg "NUM_INSTANCES"
	#puts "DEBUG: #define [xget_dname "XPco" $arg] [llength $periphs]"
	puts $file_handle "#define [xget_dname "XPci" $arg] [llength $periphs]"
	# these are the defines we would like to have
	set args [list "C_BASEADDR" "C_HIGHADDR" "CLOCK_HZ"]
	# Check if it is a driver parameter
	lappend newargs 
	foreach arg $args {
	    set value [xget_value $drv_handle "PARAMETER" $arg]
	    if {[llength $value] == 0} {
		lappend newargs $arg
	    } else {
		#puts "Check if driver parameter: #define [xget_dname "XPci" $arg] [xget_value $drv_handle "PARAMETER" $arg]"
		puts $file_handle "#define [xget_dname "XPci" $arg] [xget_value $drv_handle "PARAMETER" $arg]"
	    }
	}
	set args $newargs
	# Print all parameters for all peripherals
	set device_id 0
	foreach periph $periphs {
	    # hardware parameters
	    foreach arg $args {
		if {[string compare -nocase "DEVICE_ID" $arg] == 0} {
		    set value $device_id
		    incr device_id
		} else {
		    set value [xget_param_value $periph $arg]
		}
		if {[llength $value] == 0} {
		    set value 0
		}
		set value [xformat_addr_string $value $arg]
		#puts "Print all parameters: #define [xget_name $periph $arg] $value"
		puts $file_handle "#define [xget_name $periph $arg] $value"
	    }
	    # hardcoded addresses for PCI memory spaces
	    puts $file_handle "#define [xget_name $periph "CONFIG_ADDR"] 0x3C000000"
	    puts $file_handle "#define [xget_name $periph "CONFIG_DATA"] 0x3C000004"
	    puts $file_handle "#define [xget_name $periph "LCONFIG_ADDR"] 0x3E000000"
	    puts $file_handle "#define [xget_name $periph "MEM_BASEADDR"] 0x20000000"
	    puts $file_handle "#define [xget_name $periph "MEM_HIGHADDR"] 0x37FFFFFF"
	    puts $file_handle "#define [xget_name $periph "IO_BASEADDR"] 0x38000000"
	    puts $file_handle "#define [xget_name $periph "IO_HIGHADDR"] 0x3BFFFFFF"
	}		
	#puts "\n/******************************************************************/\n"
	puts $file_handle "\n/******************************************************************/\n"
	close $file_handle
    }

    if {$level == 1} {
	# Open include file
	set file_handle [xopen_include_file "xparameters.h"]	
	# Get all peripherals connected to this driver
	set periphs [xget_periphs $drv_handle] 
	# Define NUM_INSTANCES
	set arg "NUM_INSTANCES"
	#puts "DEBUG: #define [xget_dname "XPci" $arg] [llength $periphs]"
	puts $file_handle "#define [xget_dname "XPci" $arg] [llength $periphs]"
	# these are the defines we would like to have
	set args [list "DEVICE_ID" "C_BASEADDR" "C_HIGHADDR" "CLOCK_HZ"]
	# Check if it is a driver parameter
	lappend newargs 
	foreach arg $args {
	    set value [xget_value $drv_handle "PARAMETER" $arg]
	    if {[llength $value] == 0} {
		lappend newargs $arg
	    } else {
		#puts "Check if driver parameter: #define [xget_dname "XPci" $arg] [xget_value $drv_handle "PARAMETER" $arg]"
		puts $file_handle "#define [xget_dname "XPci" $arg] [xget_value $drv_handle "PARAMETER" $arg]"
	    }
	}
	set args $newargs
	# Print all parameters for all peripherals
	set device_id 0
	foreach periph $periphs {
	    # hardware parameters
	    foreach arg $args {
		if {[string compare -nocase "DEVICE_ID" $arg] == 0} {
		    set value $device_id
		    incr device_id
		} else {
		    set value [xget_param_value $periph $arg]
		}
		if {[llength $value] == 0} {
		    set value 0
		}
		set value [xformat_addr_string $value $arg]
		#puts "Print all parameters: #define [xget_name $periph $arg] $value"
		puts $file_handle "#define [xget_name $periph $arg] $value"
	    }
	    # hardcoded addresses for PCI memory spaces
	    puts $file_handle "#define [xget_name $periph "CONFIG_ADDR"] 0x3C000000"
	    puts $file_handle "#define [xget_name $periph "CONFIG_DATA"] 0x3C000004"
	    puts $file_handle "#define [xget_name $periph "LCONFIG_ADDR"] 0x3E000000"
	    puts $file_handle "#define [xget_name $periph "MEM_BASEADDR"] 0x20000000"
	    puts $file_handle "#define [xget_name $periph "MEM_HIGHADDR"] 0x37FFFFFF"
	    puts $file_handle "#define [xget_name $periph "IO_BASEADDR"] 0x38000000"
	    puts $file_handle "#define [xget_name $periph "IO_HIGHADDR"] 0x3BFFFFFF"
	}		
	#puts "\n/******************************************************************/\n"
	puts $file_handle "\n/******************************************************************/\n"
	close $file_handle

	# generate xpci_g.c
	xdefine_config_file $drv_handle "xpci_g.c" "XPci" "DEVICE_ID" "C_BASEADDR"
    }
}
