/*-----------------------------------------------------------------------------
*     $Date: 2004/01/17 00:47:45 $
*     $RCSfile: xtouchscreen_l.c,v $
*----------------------------------------------------------------------------*/

/******************************************************************************
*
*     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
*     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
*     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
*     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
*     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
*     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
*     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
*     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
*     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
*     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
*     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
*     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*     FOR A PARTICULAR PURPOSE.
*     
*     (c) Copyright 2004 Xilinx, Inc.
*     All rights reserved.
*
*****************************************************************************/
/*****************************************************************************/
/**
*
* @file xtouchscreen_l.c
*
* This file contains low-level driver functions that can be used to access the
* device.  The user should refer to the hardware device specification for more
* details of the device operation.
*
* <pre>
* MODIFICATION HISTORY:
*
* Ver   Who  Date     Changes
* ----- ---- -------- -----------------------------------------------
* 1.00a ch   08/08/02 First release
* </pre>
*
******************************************************************************/

/***************************** Include Files *********************************/

#include "xbasic_types.h"
#include "xenv.h"
#include "xtouchscreen_l.h"

/************************** Constant Definitions *****************************/

/**************************** Type Definitions *******************************/

/***************** Macros (Inline Functions) Definitions *********************/

/************************** Function Prototypes ******************************/

/************************** Variable Definitions *****************************/

/****************************************************************************/
/**
*
* This function reads a digitized value from the touchscreen controller.
*
* @param    BaseAddress contains the base address of the touchscreen
*           controller.
* @param    Channel addresses the channel to be read.
*
* @return   Digitized value of the addressed channel.
*
* @note     None.
*
*****************************************************************************/
Xuint32 XTouchscreen_GetValue(Xuint32 BaseAddress, Xuint8 Channel)
{
    Xuint32 ReadVal;

    XTouchscreen_mWriteCtrlReg(BaseAddress, Channel);
    XENV_USLEEP(100);
    ReadVal = XTouchscreen_mReadCtrlReg(BaseAddress);
    XTouchscreen_mWriteCtrlReg(BaseAddress, 0xd0);

    ReadVal >>= 16;

    return ReadVal;
}

