////////////////////////////////////////////////////////////////////////////
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
////////////////////////////////////////////////////////////////////////////

module pci_arbiter (
  pci_req5_in_n, // I
  pci_req4_in_n, // I
  pci_req3_in_n, // I
  pci_req2_in_n, // I
  pci_req1_in_n, // I
  pci_req0_in_n, // I

  pci_gnt5_out_n, // O
  pci_gnt4_out_n, // O
  pci_gnt3_out_n, // O
  pci_gnt2_out_n, // O
  pci_gnt1_out_n, // O
  pci_gnt0_out_n, // O

  pci_frame_in_n, // I
  pci_irdy_in_n,  // I
  pci_clk,        // I
  pci_reset       // I
  );

input           pci_req5_in_n, pci_req4_in_n, pci_req3_in_n;
input           pci_req2_in_n, pci_req1_in_n, pci_req0_in_n;

output          pci_gnt5_out_n, pci_gnt4_out_n, pci_gnt3_out_n;
output          pci_gnt2_out_n, pci_gnt1_out_n, pci_gnt0_out_n;

input           pci_frame_in_n, pci_irdy_in_n;
input           pci_clk, pci_reset;

wire            pci_gnt5_out, pci_gnt4_out, pci_gnt3_out;
wire            pci_gnt2_out, pci_gnt1_out, pci_gnt0_out;

assign pci_gnt5_out_n = ~pci_gnt5_out;
assign pci_gnt4_out_n = ~pci_gnt4_out;
assign pci_gnt3_out_n = ~pci_gnt3_out;
assign pci_gnt2_out_n = ~pci_gnt2_out;
assign pci_gnt1_out_n = ~pci_gnt1_out;
assign pci_gnt0_out_n = ~pci_gnt0_out;

pciarbr6 pciarbr6(
  .pci_req5_in (~pci_req5_in_n), // I
  .pci_req4_in (~pci_req4_in_n), // I
  .pci_req3_in (~pci_req3_in_n), // I
  .pci_req2_in (~pci_req2_in_n), // I
  .pci_req1_in (~pci_req1_in_n), // I
  .pci_req0_in (~pci_req0_in_n), // I

  .pci_gnt5_out(pci_gnt5_out),   // O
  .pci_gnt4_out(pci_gnt4_out),   // O
  .pci_gnt3_out(pci_gnt3_out),   // O
  .pci_gnt2_out(pci_gnt2_out),   // O
  .pci_gnt1_out(pci_gnt1_out),   // O
  .pci_gnt0_out(pci_gnt0_out),   // O

  .pci_frame_in(~pci_frame_in_n),// I
  .pci_irdy_in (~pci_irdy_in_n), // I
  .pci_clk     (pci_clk),        // I
  .pci_reset   (pci_reset)       // I
  );

endmodule
