/******************************************************************************
*     $Date: 2004/01/01 01:29:11 $
*     $RCSfile: dispbmp.c,v $
*******************************************************************************

*******************************************************************************
*
*     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
*     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
*     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
*     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
*     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
*     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
*     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
*     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
*     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
*     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
*     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
*     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*     FOR A PARTICULAR PURPOSE.
*     
*     (c) Copyright 2004 Xilinx, Inc.
*     All rights reserved.
*
******************************************************************************/

/* Uncomment one of the following seven header files
 * to display a different bitmap image               */
#include "xilinx_logo_greyongrey.bmp.h"
//#include "ml300splash.bmp.h"
//#include "ml300splashsmall.bmp.h"
//#include "cityscape.bmp.h"    // 125
//#include "oceanscape.bmp.h"   // 130
//#include "countryscape.bmp.h"   // 127
//#include "desertscape.bmp.h"  // 128

#include "xbasic_types.h"
#include "xtft.h"
#include "xtft_l.h"
#include "xcache_l.h"
#include "xparameters.h"

#define TFT_DEVICE_ID    XPAR_PLB_TFT_CNTLR_REF_0_DEVICE_ID

#define BUFFER_COLUMNS   1024

#define STATUS_CHECK(Status) { if (Status != XST_SUCCESS) { return Status; } }

int main ()
{
  XStatus Status;
  XTft Tft;
  unsigned int count, x, y;
  
  XCache_EnableICache(0x80000001);
  XCache_EnableDCache(0x80000001);

  /* Initialize TFT */
  Status = XTft_Initialize(&Tft, TFT_DEVICE_ID);
  STATUS_CHECK(Status);

  // Clear Screen
  for(y=0; y<480; y++) {
    for(x=0; x<640; x++) {
      XTft_mSetPixel(*(Xuint32 *)Tft.BaseAddress, x, y, 0x0);
    }
  }

  //Print image in center of screen
  count = 0;

  for(y=240-(bitmap[1]/2); y<((240-(bitmap[1]/2))+(bitmap[1])); y++) {
    for(x=320-(bitmap[0]/2); x<((320-(bitmap[0]/2))+(bitmap[0])); x++) {
      XTft_mSetPixel(*(Xuint32 *)Tft.BaseAddress, x, y, bitmap[count+4]);
      count++;
    }
  }

  return 0;

}

