/*-----------------------------------------------------------------------------
//     $Date: 2004/01/15 14:26:53 $
//     $RCSfile: hello.c,v $
//-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "xparameters.h"
#include "sleep.h"
#include "xgpio_l.h"

#define GPIO_0_BASEADDR XPAR_MY_OPB_GPIO_0_BASEADDR_0
#define GPIO_1_BASEADDR XPAR_MY_OPB_GPIO_0_BASEADDR_1

static void putc(char c)
{
  XGpio_mSetDataReg(GPIO_0_BASEADDR, (unsigned int) c);
  XGpio_mSetDataReg(GPIO_1_BASEADDR, (unsigned int) c);
}

static void printf(char *s)
{
  while (*s) {
    putc(*s);
    usleep(250000);
    s++;
  }
}

int main(void)
{
  /* set gpio bits to all output */
  XGpio_mSetDataDirection(GPIO_0_BASEADDR, 0);
  XGpio_mSetDataDirection(GPIO_1_BASEADDR, 0);

  printf("Hello world\r\n");

  return 0;
}
