/******************************************************************************
*     $Date: 2004/01/01 01:25:44 $
*     $RCSfile: hello.c,v $
*******************************************************************************

*******************************************************************************
*
*     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
*     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
*     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
*     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
*     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
*     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
*     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
*     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
*     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
*     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
*     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
*     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*     FOR A PARTICULAR PURPOSE.
*     
*     (c) Copyright 2004 Xilinx, Inc.
*     All rights reserved.
*
******************************************************************************/
#include "xbasic_types.h"
#include "xstatus.h"
#include "xtft.h"
#include "xparameters.h"
//#include "exit.h"

#define XPAR_TFT_0_DEVICE_ID XPAR_PLB_TFT_CNTLR_REF_0_DEVICE_ID

#define STATUS_CHECK(Status)         \
    {                                \
        if (Status != XST_SUCCESS)   \
        {                            \
            return Status;           \
        }                            \
    }

static void printChars(XTft *TftPtr, Xuint32 fg, Xuint32 bg)
{
  Xint8 i;

  XTft_SetColor(TftPtr, fg, bg);
  for (i = 0x20; i < 0x80; i++)
    XTft_Write(TftPtr, i);

  XTft_Write(TftPtr, 0xa);
}


int main()
{
  XTft Tft;
  XStatus Status;
   
  /*
   * Initialize the TFT driver
   * use the device ID in xparameters.h
   */
  
  Status = XTft_Initialize(&Tft, XPAR_TFT_0_DEVICE_ID);
  STATUS_CHECK(Status);
  
  XTft_ClearScreen(&Tft);
  printChars(&Tft, 0xffffff, 0x0);
  printChars(&Tft, 0xff, 0x0);
  printChars(&Tft, 0xff00, 0x0);
  printChars(&Tft, 0xff0000, 0x0);
  printChars(&Tft, 0xffffff, 0xff);
  printChars(&Tft, 0xffffff, 0xff00);
  printChars(&Tft, 0xffffff, 0xff0000);
  
  return 0;
}
