/*-----------------------------------------------------------------------------
//     $Date: 2004/01/15 14:22:03 $
//     $RCSfile: xromled.c,v $
//-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "xparameters.h"
#include "xgpio_l.h"
#include "sleep.h"
#include "xromlog.h"

static unsigned int value;
static int i;

#define GPIO_0_BASEADDR XPAR_MY_OPB_GPIO_0_BASEADDR_0
#define GPIO_1_BASEADDR XPAR_MY_OPB_GPIO_0_BASEADDR_1

void XromLedInit(void)
{
  value = 0;
  i = 0;
  XGpio_mSetDataDirection(GPIO_0_BASEADDR, 0);
  XGpio_mSetDataDirection(GPIO_1_BASEADDR, 0);
}

void XromLedToggle(void)
{
  i++;
  if (i == 100000)
  {
    value = (value + 1) & 0x3;
    XGpio_mSetDataReg(GPIO_0_BASEADDR, value);
    XGpio_mSetDataReg(GPIO_1_BASEADDR, value);
    i = 0;
  }
}

void XromTestLed(void)
{
  unsigned int j;

  XromLogString("  Turning all LEDs off\r\n");
  XGpio_mSetDataReg(GPIO_0_BASEADDR, 0);
  XGpio_mSetDataReg(GPIO_1_BASEADDR, 0);
#if SIM==0
  sleep(5);
#endif

  XromLogString("  Turning all LEDs on\r\n");
  XGpio_mSetDataReg(GPIO_0_BASEADDR, 0xffffffff);
  XGpio_mSetDataReg(GPIO_1_BASEADDR, 0xffffffff);
#if SIM==0
  sleep(5);
#endif

  XromLogString("  Walking one on 32 bits\r\n");
  j = 1;
  while (j != 0)
  {
    XGpio_mSetDataReg(GPIO_0_BASEADDR, j);
    XGpio_mSetDataReg(GPIO_1_BASEADDR, j);
#if SIM==0
    sleep(1);
#endif
    j *= 2;
  }

  XromLogString("  Walking zero on 32 bits\r\n");
  j = 1;
  while (j != 0)
  {
    XGpio_mSetDataReg(GPIO_0_BASEADDR, ~j);
    XGpio_mSetDataReg(GPIO_1_BASEADDR, ~j);
#if SIM==0
    sleep(1);
#endif
    j *= 2;
  }

  XromLogString("  LED test completed\r\n");
}
