/*-----------------------------------------------------------------------------
//     $Date: 2003/05/29 16:25:42 $
//     $RCSfile: xromtests.c,v $
//-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "globaltypes.h"
#include "xrominput.h"
#include "xrom.h"
#include "xromlog.h"
#include "xromtestram.h"
#include "xromled.h"
#include "xromiic.h"


static void doLog(char *s, unsigned int memStart, unsigned int memLen)
{
  XromLogString(s);
  XromLogString(" [");
  XromLogHex(memStart);
  XromLogString(" - ");
  XromLogHex(memStart+memLen-1);
  XromLogString("]\r\n");
}

void TestsMenu()
{
  XromLogLn();
  XromLogString("Main.Tests\r\n");
  XromLogString("  2. Test BRAM\r\n");
  XromLogString("  3. Test DDR SDRAM\r\n");
  XromLogString("  7. Test LEDs\r\n");
  XromLogString("  8. Test IIC\r\n");
  
  XromLogString("  0. Main Menu\r\n");
}

void TestsInput(char ch)
{
  unsigned int memStart;
  unsigned int memLen;

  switch(ch)
  {
  case '2':
#if SIM==1
    memStart = 0xffffff00;
    memLen = 128;
#else
    memStart = 0xffff8000;
    memLen = 32*1024;
#endif
    doLog("\r\nTesting BRAM", memStart, memLen);
    TestRam(memStart, memLen, 10, 0);
    break;
  case '3':
    memStart = 0x0;
#if SIM==1
    memLen = 128;
#else
    memLen = 128*1024*1024;
#endif
    doLog("\r\nTesting DDR SDRAM", memStart, memLen);
    TestRam(memStart, memLen, 10, 30);
    break;
  case '7':
    XromLogString("\r\nTesting LEDs\r\n");
    XromTestLed();
    break;
  case '8':
    XromLogString("\r\nTesting IIC\r\n");
    XromTestIic();
    break;
  case 0x1b:
  case '0':
    PopMenu(&printMenu, &handleInput);
    doPrintMenu = true;
    break;
  default:
    doPrintMenu = true;
    break;
  } 
}
