/*-----------------------------------------------------------------------------
//     $Date: 2004/01/07 21:54:39 $
//     $RCSfile: xromcache.c,v $
//-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "globaltypes.h"
#include "xromcache.h"
#include "xrom.h"
#include "xromlog.h"
#include "xcache_l.h"

#define REGIONS           0x80000001

bool icache_enabled;
bool dcache_enabled;

void XromCacheInit()
{
#ifdef V2PDK
  XCache_EnableICache(REGIONS);
  XCache_EnableDCache(REGIONS);

  icache_enabled = true;
  dcache_enabled = true;
#else
  icache_enabled = false;
  dcache_enabled = false;
  XCache_DisableICache();
  XCache_DisableDCache();
#endif
}

void XromCacheMenu()
{
  XromLogString("\r\n");

  XromLogString("Main.Cache Settings\r\n");
  XromLogString("  1. Instruction cache is ");
  if (icache_enabled)
    XromLogString("enabled");
  else
    XromLogString("disabled");
  XromLogLn();
  XromLogString("  2. Data cache is ");
  if (dcache_enabled)
    XromLogString("enabled");
  else
    XromLogString("disabled");
  XromLogLn();
  XromLogString("  0. Main Menu\r\n");
}

void XromCacheInput(char ch)
{
  switch(ch)
  {
  case '1':
    icache_enabled = !icache_enabled;
    if (icache_enabled)
      XCache_EnableICache(REGIONS);
    else
      XCache_DisableICache();
    doPrintMenu = true;
    break;
  case '2':
    dcache_enabled = !dcache_enabled;
    if (dcache_enabled)
      XCache_EnableDCache(REGIONS);
    else
      XCache_DisableDCache();
    doPrintMenu = true;
    break;
  case 0x1b:
  case '0':
    PopMenu(&printMenu, &handleInput);
    doPrintMenu = true;
    break;
  default:
    doPrintMenu = true;
    break;
  }
}
