/*-----------------------------------------------------------------------------
//     $Date: 2004/03/10 23:35:36 $
//     $RCSfile: xromled.c,v $
//-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "sleep.h"
#include "xgpio_l.h"
#include "xromlog.h"
#include "xromabort.h"
#include "xparameters.h"

#define GPIO_0_BASEADDR XPAR_MY_OPB_GPIO_0_BASEADDR_0
#define GPIO_1_BASEADDR XPAR_MY_OPB_GPIO_0_BASEADDR_1

//#define SPEED_UP

static unsigned long value;
static int i;
static unsigned long  myValue =  0x00000001;
static unsigned long  myValue2 = 0x00000001;
static char a = 1;
static char b = 1;
static char c = 0;
static char d = 0;

void XromLedInit(void)
{
  value = 0;
  i = 0;
  XGpio_mSetDataDirection(GPIO_0_BASEADDR, 0x0);
  XGpio_mSetDataDirection(GPIO_1_BASEADDR, 0x0);
}

void XromLedToggle(void)
{
  unsigned long value2, value3;

  i++;
  if (i == 20000)
  {
    if (a == 1) {
      myValue = myValue << 1; }
    else {
      myValue = myValue >> 1; }
    value = myValue;
    // write value to second GPIO
    XGpio_mSetDataReg(GPIO_1_BASEADDR, value);

    if (myValue == 0x80000000) 
      {
        a = 0;
        c++; 
      }
    else if (myValue == 0x00000001) 
      {
        a = 1;
        d++;
      }


    if (b == 1) {
      myValue2 = myValue2 << 1; }
    else {
      myValue2 = myValue2 >> 1; }
      
    value2 = c & 0xf;  // keep lower four bits of c
    value3 = d & 0xf;  // keep lower four bits of d
    value = myValue2 << 8;  // get moving bits
    value2 = value2 << 4;  // put c into left side
    value = value + value2 + value3; // put it all together now
    value = value & 0x0000ffff;  // mask off the rest to be safe
    // write value to first GPIO
    XGpio_mSetDataReg(GPIO_1_BASEADDR, value);

    if (myValue2 == 0x00000080) 
      {
        b = 0;
      }
    else if (myValue2 == 0x00000001) 
      {
        b = 1;
      }

    i = 0;
  }
}

void XromTestLed(void)
{
//  unsigned int j;
  unsigned long value2, value3;

  myValue2 = 0x0;
  myValue  = 0x1;
  a = 1;
  b = 2;
  
  for (;;)
  {

  i++;
  if (i == 50000)
    {
      value3 = 0x90000004;
      value2  = *(volatile unsigned long *) value3;
      * (volatile unsigned long *) value3 = value2 | 0x10000000; 
    }
  if (i == 100000)
    {
      value3 = 0x90000004;
      value2  = *(volatile unsigned long *) value3;
      * (volatile unsigned long *) value3 = value2 & 0xEFFFFFFF; 
    }
    
  if (i == 200000)
  {
    if (a == 1) {
      myValue = myValue << 1; }
    else if (a == 0){
      myValue = myValue >> 1; }
    else {
      myValue = myValue; }
    value = myValue;
    // write value to second GPIO
    XGpio_mSetDataReg(GPIO_1_BASEADDR, value);

    if (myValue == 0x80000000) 
      {
        a = 2;
        b = 0;
        myValue = 0x0;
        myValue2 = 0x10000;
      }
    else if (myValue == 0x00000001) 
      {
        a = 1;
        b = 2; 
      }


    if (b == 1) {
      myValue2 = myValue2 << 1; }
    else if (b == 0) {
      myValue2 = myValue2 >> 1; }
    else {
      myValue2 = myValue2; }
    value = myValue2;
    value2 = value & 0x00000FF0;  // get logical bits 11-4, Map to phy 15-8
    value2 = value2 << 4;         // shift right 4 position
    value3 = value & 0x0000F000;  // get bits 15-12
    value  = value & 0x0000000F;  // preserve bits 3-0
    value3 = value3 >> 11 ;       // shift left 11 position
    value3 = value3 &0x0000001E;  // keep bits around; clear others
    if (value3 & 0x8)
      {
        value3 = value3 | 0x20;
      }
    if (value3 & 0x4)
      {
        value3 = value3 | 0x40;
      }
    if (value3 & 0x2)
      {
        value3 = value3 | 0x80;
      }
    value3 = value3 & 0x000000F0;      // keep only the bits we want
    value  = value + value2 + value3;  // get all bits together finaly!     
   
    // write value to first GPIO
    XGpio_mSetDataReg(GPIO_0_BASEADDR, value);

    if (myValue2 == 0x00008000) 
      {
        a = 2; 
        b = 0; 
      }
    else if (myValue2 == 0x00000001) 
      {
        a = 1;
        b = 2;
        myValue2 = 0x0;
        myValue  = 0x1;
      }

    i = 0;
    
    if (AbortByKeyboard()) break;
    }
  }

/*
  XromLogString("  Turning all LEDs off\r\n");
  //gpio_Write(GPIO_DATA_REG, 0);
  //gpio_Write(GPIO_DATA_REG+8, 0);
  XGpio_mWriteReg(GPIO_BASEADDR, XGPIO_DATA_OFFSET, 0xffffffff);
  XGpio_mWriteReg(GPIO_BASEADDR, XGPIO_DATA_OFFSET+0x8, 0xffffffff);
#ifndef SPEED_UP
  sleep(1);
#endif

  XromLogString("  Turning all LEDs on\r\n");
  //gpio_Write(GPIO_DATA_REG, 0xffffffff);
  //gpio_Write(GPIO_DATA_REG+8, 0xffffffff);
  XGpio_mWriteReg(GPIO_BASEADDR, XGPIO_DATA_OFFSET, 0xffffffff);
  XGpio_mWriteReg(GPIO_BASEADDR, XGPIO_DATA_OFFSET+0x8, 0xffffffff);
#ifndef SPEED_UP
  sleep(1);
#endif


  XromLogString("  Walking one on 16 bits\r\n");
  j = 1;
  while (j != 0)
  {
    //gpio_Write(GPIO_DATA_REG, j);
    XGpio_mWriteReg(GPIO_BASEADDR, XGPIO_DATA_OFFSET, j);
#ifndef SPEED_UP
    usleep(200000);
#endif
    j *= 2;
    if (j==65536) break;
  }

  XromLogString("  Walking one on 32 bits\r\n");
  j = 1;
  while (j != 0)
  {
    //gpio_Write(GPIO_DATA_REG+8, j);
    XGpio_mWriteReg(GPIO_BASEADDR, XGPIO_DATA_OFFSET+0x8, j);
#ifndef SPEED_UP
    usleep(200000);
#endif
    j *= 2;
  }

  XromLogString("  Walking zero on 16 bits\r\n");
  j = 1;
  while (j != 0)
  {
    //gpio_Write(GPIO_DATA_REG, ~j);
    XGpio_mWriteReg(GPIO_BASEADDR, XGPIO_DATA_OFFSET+0x8, -j);
#ifndef SPEED_UP
    usleep(200000);
#endif
    j *= 2;
    if (j==65536) break;
  }


  XromLogString("  Walking zero on 32 bits\r\n");
  j = 1;
  while (j != 0)
  {
    //gpio_Write(GPIO_DATA_REG+8, ~j);
    XGpio_mWriteReg(GPIO_BASEADDR, XGPIO_DATA_OFFSET+0x8, -j);
#ifndef SPEED_UP
    usleep(200000);
#endif
    j *= 2;
  }

  //gpio_Write(GPIO_DATA_REG,0x0);
  XGpio_mWriteReg(GPIO_BASEADDR, XGPIO_DATA_OFFSET, 0);
*/
  XromLogString("  LED test completed\r\n");
}

