/*-----------------------------------------------------------------------------
//     $Date: 2004/01/15 14:26:02 $
//     $RCSfile: xromsmiley.c,v $
//-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "globaltypes.h"
#include "xromlog.h"
#include "xromled.h"
#include "xromabort.h"
#include "xgpio_l.h"
#include "xromsmiley.h"
#include "xparameters.h"
#include "sleep.h"

#define GPIO_BASEADDR XPAR_MY_OPB_GPIO_0_BASEADDR_0

static unsigned long  smileFace0[18];
static unsigned long  smileFace1[18];
static unsigned long  smileFace2[18];
static unsigned long  smileFace3[18];
static unsigned long  smileFace4[18];
static unsigned long  smileFace5[18];
static unsigned long  smileFace6[18];
static unsigned long  smileFace7[18];
static unsigned long  smileFace8[18];
static unsigned long  smileFace9[18];
static unsigned long smileFace10[18];
static unsigned long smileFace11[18];
static unsigned long smileFace12[18];
static unsigned long smileFace13[18];
static unsigned long smileFace14[18];
static unsigned long smileFace15[18];
static unsigned long smileFace16[18];
static unsigned long smileFace17[18];
static unsigned long screenBaseAdr = 0x07e00000;
static unsigned long mrSmiley0_0[18];
static unsigned long mrSmiley0_1[18];
static unsigned long mrSmiley0_2[18];
static unsigned long mrSmiley0_3[18];
static unsigned long mrSmiley0_4[18];
static unsigned long mrSmiley0_5[18];
static unsigned long mrSmiley0_6[18];
static unsigned long mrSmiley0_7[18];
static unsigned long mrSmiley0_8[18];
static unsigned long mrSmiley0_9[18];
static unsigned long mrSmiley0_10[18];
static unsigned long mrSmiley0_11[18];
static unsigned long mrSmiley0_12[18];
static unsigned long mrSmiley0_13[18];
static unsigned long mrSmiley0_14[18];
static unsigned long mrSmiley0_15[18];
static unsigned long mrSmiley0_16[18];
static unsigned long mrSmiley0_17[18];
static unsigned long mrSmiley1_0[18];
static unsigned long mrSmiley1_1[18];
static unsigned long mrSmiley1_2[18];
static unsigned long mrSmiley1_3[18];
static unsigned long mrSmiley1_4[18];
static unsigned long mrSmiley1_5[18];
static unsigned long mrSmiley1_6[18];
static unsigned long mrSmiley1_7[18];
static unsigned long mrSmiley1_8[18];
static unsigned long mrSmiley1_9[18];
static unsigned long mrSmiley1_10[18];
static unsigned long mrSmiley1_11[18];
static unsigned long mrSmiley1_12[18];
static unsigned long mrSmiley1_13[18];
static unsigned long mrSmiley1_14[18];
static unsigned long mrSmiley1_15[18];
static unsigned long mrSmiley1_16[18];
static unsigned long mrSmiley1_17[18];
static unsigned int redPoints, bluePoints;

void setSmileyBG (unsigned long bgColor)
{
  unsigned int i;
  // initialize whole to bgColor
  for(i=0; i<18; i++)
  {
    smileFace0[i]  = bgColor;
    smileFace1[i]  = bgColor;
    smileFace2[i]  = bgColor;
    smileFace3[i]  = bgColor;
    smileFace4[i]  = bgColor;
    smileFace5[i]  = bgColor;
    smileFace6[i]  = bgColor;
    smileFace7[i]  = bgColor;
    smileFace8[i]  = bgColor;
    smileFace9[i]  = bgColor;
    smileFace10[i] = bgColor;
    smileFace11[i] = bgColor;
    smileFace12[i] = bgColor;
    smileFace13[i] = bgColor;
    smileFace14[i] = bgColor;
    smileFace15[i] = bgColor;
    smileFace16[i] = bgColor;
    smileFace17[i] = bgColor;
  }
  return;
}

void   setSmileyEyes(unsigned long eyeWhites, unsigned long eyeIris)
{
    // eyes
    smileFace4[5]   = eyeWhites;
    smileFace4[6]   = eyeWhites;
    smileFace4[11]  = eyeWhites;
    smileFace4[12]  = eyeWhites;
    smileFace5[4]   = eyeWhites;
    smileFace5[5]   = eyeIris;
    smileFace5[6]   = eyeIris;
    smileFace5[7]   = eyeWhites;
    smileFace5[10]  = eyeWhites;
    smileFace5[11]  = eyeIris;
    smileFace5[12]  = eyeIris;
    smileFace5[13]  = eyeWhites;
    smileFace6[5]   = eyeWhites;
    smileFace6[6]   = eyeWhites;
    smileFace6[11]  = eyeWhites;
    smileFace6[12]  = eyeWhites;
    return;
}

void setSmileyNose(unsigned long noseColor)
{
    // nose
    smileFace7[8]   = noseColor;
    smileFace7[9]   = noseColor;
    smileFace8[8]   = noseColor;
    smileFace8[9]   = noseColor;
    smileFace9[7]   = noseColor;
    smileFace9[8]   = noseColor;
    smileFace9[9]   = noseColor;
    smileFace9[10]  = noseColor;
    return;
}

void setSmileyMouth (unsigned long mouthColor)
{
    // mouth
    smileFace11[5]  = mouthColor;
    smileFace11[12] = mouthColor;
    smileFace12[5]  = mouthColor;
    smileFace12[6]  = mouthColor;
    smileFace12[11] = mouthColor;
    smileFace12[12] = mouthColor;
    smileFace13[7]  = mouthColor;
    smileFace13[8]  = mouthColor;
    smileFace13[9]  = mouthColor;
    smileFace13[10] = mouthColor;
    return;
}

void setSmileyOutline (unsigned long outlineColor)
{
    // outline
    smileFace0[6]   = outlineColor;
    smileFace0[7]   = outlineColor;
    smileFace0[8]   = outlineColor;
    smileFace0[9]   = outlineColor;
    smileFace0[10]  = outlineColor;
    smileFace0[11]  = outlineColor;
    smileFace1[4]   = outlineColor;
    smileFace1[5]   = outlineColor;
    smileFace1[6]   = outlineColor;
    smileFace1[11]  = outlineColor;
    smileFace1[12]  = outlineColor;
    smileFace1[13]  = outlineColor;
    smileFace2[3]   = outlineColor;
    smileFace2[14]  = outlineColor;
    smileFace3[2]   = outlineColor;
    smileFace3[15]  = outlineColor;
    smileFace4[1]   = outlineColor;
    smileFace4[16]  = outlineColor;
    smileFace5[1]   = outlineColor;
    smileFace5[16]  = outlineColor;
    smileFace6[0]   = outlineColor;
    smileFace6[17]  = outlineColor;
    smileFace7[0]   = outlineColor;
    smileFace7[17]  = outlineColor;
    smileFace8[0]   = outlineColor;
    smileFace8[17]  = outlineColor;
    smileFace9[0]   = outlineColor;
    smileFace9[17]  = outlineColor;
    smileFace10[0]  = outlineColor;
    smileFace10[17] = outlineColor;
    smileFace11[0]  = outlineColor;
    smileFace11[17] = outlineColor;
    smileFace12[1]  = outlineColor;
    smileFace12[16] = outlineColor;
    smileFace13[1]  = outlineColor;
    smileFace13[16] = outlineColor;
    smileFace14[2]  = outlineColor;
    smileFace14[15] = outlineColor;
    smileFace15[3]  = outlineColor;
    smileFace15[14] = outlineColor;
    smileFace16[4]  = outlineColor;
    smileFace16[5]  = outlineColor;
    smileFace16[12] = outlineColor;
    smileFace16[13] = outlineColor;
    smileFace17[6]  = outlineColor;
    smileFace17[7]  = outlineColor;
    smileFace17[8]  = outlineColor;
    smileFace17[9]  = outlineColor;
    smileFace17[10] = outlineColor;
    smileFace17[11] = outlineColor;
    return;
}

void setCurrentSmiley (unsigned char whichSmiley)
{
  unsigned int i;

  for (i=0; i<18; i++)
  {
    if (whichSmiley == 1)
    {
      smileFace0[i] = mrSmiley0_0[i];
      smileFace1[i] = mrSmiley0_1[i];
      smileFace2[i] = mrSmiley0_2[i];
      smileFace3[i] = mrSmiley0_3[i];
      smileFace4[i] = mrSmiley0_4[i];
      smileFace5[i] = mrSmiley0_5[i];
      smileFace6[i] = mrSmiley0_6[i];
      smileFace7[i] = mrSmiley0_7[i];
      smileFace8[i] = mrSmiley0_8[i];
      smileFace9[i] = mrSmiley0_9[i];
      smileFace10[i]= mrSmiley0_10[i];
      smileFace11[i]= mrSmiley0_11[i];
      smileFace12[i]= mrSmiley0_12[i];
      smileFace13[i]= mrSmiley0_13[i];
      smileFace14[i]= mrSmiley0_14[i];
      smileFace15[i]= mrSmiley0_15[i];
      smileFace16[i]= mrSmiley0_16[i];
      smileFace17[i]= mrSmiley0_17[i];
    }
    if (whichSmiley == 2)
    {
      smileFace0[i] = mrSmiley1_0[i];
      smileFace1[i] = mrSmiley1_1[i];
      smileFace2[i] = mrSmiley1_2[i];
      smileFace3[i] = mrSmiley1_3[i];
      smileFace4[i] = mrSmiley1_4[i];
      smileFace5[i] = mrSmiley1_5[i];
      smileFace6[i] = mrSmiley1_6[i];
      smileFace7[i] = mrSmiley1_7[i];
      smileFace8[i] = mrSmiley1_8[i];
      smileFace9[i] = mrSmiley1_9[i];
      smileFace10[i]= mrSmiley1_10[i];
      smileFace11[i]= mrSmiley1_11[i];
      smileFace12[i]= mrSmiley1_12[i];
      smileFace13[i]= mrSmiley1_13[i];
      smileFace14[i]= mrSmiley1_14[i];
      smileFace15[i]= mrSmiley1_15[i];
      smileFace16[i]= mrSmiley1_16[i];
      smileFace17[i]= mrSmiley1_17[i];    }
  }
  return;
}

void smileyInit(
  unsigned char whichSmiley,
  unsigned long smBGColor,
  unsigned long smEyeWhiteColor,
  unsigned long smEyeColor,
  unsigned long smNoseColor,
  unsigned long smMouthColor,
  unsigned long smOutlineColor)
{
  unsigned int i;

  setSmileyBG(smBGColor);
  setSmileyEyes(smEyeWhiteColor,smEyeColor);
  setSmileyNose(smNoseColor);
  setSmileyMouth(smMouthColor);
  setSmileyOutline(smOutlineColor);

  for (i=0; i<18; i++)
  {
    if (whichSmiley == 1)
    {
      mrSmiley0_0[i]  = smileFace0[i];
      mrSmiley0_1[i]  = smileFace1[i];
      mrSmiley0_2[i]  = smileFace2[i];
      mrSmiley0_3[i]  = smileFace3[i];
      mrSmiley0_4[i]  = smileFace4[i];
      mrSmiley0_5[i]  = smileFace5[i];
      mrSmiley0_6[i]  = smileFace6[i];
      mrSmiley0_7[i]  = smileFace7[i];
      mrSmiley0_8[i]  = smileFace8[i];
      mrSmiley0_9[i]  = smileFace9[i];
      mrSmiley0_10[i] = smileFace10[i];
      mrSmiley0_11[i] = smileFace11[i];
      mrSmiley0_12[i] = smileFace12[i];
      mrSmiley0_13[i] = smileFace13[i];
      mrSmiley0_14[i] = smileFace14[i];
      mrSmiley0_15[i] = smileFace15[i];
      mrSmiley0_16[i] = smileFace16[i];
      mrSmiley0_17[i] = smileFace17[i];
    }
    if (whichSmiley == 2)
    {
      mrSmiley1_0[i]  = smileFace0[i];
      mrSmiley1_1[i]  = smileFace1[i];
      mrSmiley1_2[i]  = smileFace2[i];
      mrSmiley1_3[i]  = smileFace3[i];
      mrSmiley1_4[i]  = smileFace4[i];
      mrSmiley1_5[i]  = smileFace5[i];
      mrSmiley1_6[i]  = smileFace6[i];
      mrSmiley1_7[i]  = smileFace7[i];
      mrSmiley1_8[i]  = smileFace8[i];
      mrSmiley1_9[i]  = smileFace9[i];
      mrSmiley1_10[i] = smileFace10[i];
      mrSmiley1_11[i] = smileFace11[i];
      mrSmiley1_12[i] = smileFace12[i];
      mrSmiley1_13[i] = smileFace13[i];
      mrSmiley1_14[i] = smileFace14[i];
      mrSmiley1_15[i] = smileFace15[i];
      mrSmiley1_16[i] = smileFace16[i];
      mrSmiley1_17[i] = smileFace17[i];
    }
  }

  return;
}


void placeSmiley (unsigned int xPixAdr, unsigned int yPixAdr)
{
  unsigned int i;
  // lets draw our happy face now

  for (i=0; i<18; i++)
  {
       if(xPixAdr > (640-18))
       {
         xPixAdr = (640-18);
       }
       if(yPixAdr > (480-18))
       {
         yPixAdr = (480-18);
       }
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+0 ))) = smileFace0[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+1 ))) = smileFace1[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+2 ))) = smileFace2[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+3 ))) = smileFace3[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+4 ))) = smileFace4[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+5 ))) = smileFace5[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+6 ))) = smileFace6[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+7 ))) = smileFace7[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+8 ))) = smileFace8[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+9 ))) = smileFace9[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+10))) = smileFace10[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+11))) = smileFace11[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+12))) = smileFace12[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+13))) = smileFace13[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+14))) = smileFace14[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+15))) = smileFace15[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+16))) = smileFace16[i];
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+17))) = smileFace17[i];
  }
  return;
}

void clrMyScreen(unsigned int myColor)
{
  unsigned long myAdr;
  // clear the screen, please
  for(myAdr = screenBaseAdr; myAdr < screenBaseAdr+((2*1024*1024)-4); myAdr=myAdr+4)
    {
       * (volatile unsigned long *) myAdr = myColor;
    }
  return;
}


unsigned char detectOtherSmiley (unsigned int xPixAdr, unsigned int yPixAdr)
{
  unsigned int i;
  unsigned long data;
  unsigned char gotHim;

  // autocorrect for out of bounds
  if(xPixAdr > (640-18))
  {
    xPixAdr = (640-18);
  }
  if(yPixAdr > (480-18))
  {
    yPixAdr = (480-18);
  }
  gotHim = 0;

  // look for the other smiley on TOP side
  if (yPixAdr > 0)
  {
    for (i=0; i<18; i++);
    {
      data = *(volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr-1)));
      if ((data & 0x00FCFCFC) != 0)
      {
        gotHim = 1;
      }
    }
  }
  // look for the other smiley on BOT side
  if (yPixAdr < (480-18))
  {
    for (i=0; i<18; i++);
    {
      data = *(volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+18)));
      if ((data & 0x00FCFCFC) != 0)
      {
        gotHim = 1;
      }
    }
  }
  // look for the other smiley on LEFT side
  if (xPixAdr > 0)
  {
    for (i=0; i<18; i++);
    {
      data = *(volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr-1))+(4096*(yPixAdr+i)));
      if ((data & 0x00FCFCFC) != 0)
      {
        gotHim = 1;
      }
    }
  }
  // look for the other smiley on RIGHT side
  if (xPixAdr < (640-18))
  {
    for (i=0; i<18; i++);
    {
      data = *(volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+17))+(4096*(yPixAdr+i)));
      if ((data & 0x00FCFCFC) != 0)
      {
        gotHim = 1;
      }
    }
  }
  return(gotHim);
}

void clearSmiley (unsigned int xPixAdr, unsigned int yPixAdr, unsigned long bgColor)
{
  unsigned int i,j;

  // autocorrect for out of bounds
  if(xPixAdr > (640-18))
  {
    xPixAdr = (640-18);
  }
    if(yPixAdr > (480-18))
  {
    yPixAdr = (480-18);
  }

  // lets UNdraw our happy face now

  for (j=0; j<18; j++)
  {
    for (i=0; i<18; i++)
    {
       * (volatile unsigned long *) (screenBaseAdr+(4*(xPixAdr+i))+(4096*(yPixAdr+j ))) = bgColor;
    }
  }
  return;
}

void updatePoints(unsigned char mySmiley)
{
  unsigned int i;
  if (mySmiley == 1)
  {
    bluePoints++;
    XromLogString("BLUE Player Point!  ");
    for (i=0; i<5; i++);
    {
      clrMyScreen(BLU);
      usleep(40);
      clrMyScreen(BLK);
      usleep(40);
    }
  }
  else
  {
    redPoints++;
    XromLogString("RED  Player Point!  ");
    for (i=0; i<5; i++);
    {
      clrMyScreen(RED);
      usleep(40);
      clrMyScreen(BLK);
      usleep(40);
    }
  }
  XromLogString("Blue Points = ");
  XromLogInt(bluePoints);
  XromLogString(", Red Points =");
  XromLogInt(redPoints);
  XromLogLn();
  return;
}

/*********************************************************************
*
* FUNCTION : playMrSmileyMover
*
*********************************************************************/
void playMrSmileyMover(void)
{
  unsigned long gpioDataRead;
  unsigned int x1PixAdr, y1PixAdr;
  unsigned int x2PixAdr, y2PixAdr;
  unsigned char detected;

  clrMyScreen(BLU);

  XromLogString("Welcome to Mr Smiley's Mover\r\n");
  XromLogLn();
  XromLogString("Instructions:\r\n");
  XromLogLn();
  XromLogString("  Object of game: catch the other Mr Smiley!\r\n");
  XromLogLn();
  XromLogString("    GAME CONTROLS - Each Player will use the following:\r\n");
  XromLogLn();
  XromLogString("                  Top Button\r\n");
  XromLogString("                        ^\r\n");
  XromLogString("                        |\r\n");
  XromLogString("                        |\r\n");
  XromLogString("      Left Button  <-- move -->  Right Button\r\n");
  XromLogString("                        |\r\n");
  XromLogString("                        |\r\n");
  XromLogString("                        v\r\n");
  XromLogString("                  Bot Button\r\n");
  XromLogLn();
  XromLogString("  Press the ESC key to exit Mr Smiley's Mover\r\n");
  XromLogLn();
  XromLogLn();
  XromLogString("  Ready??");
  XromLogString("... BEGIN!\r\n");
  XromLogLn();
  sleep(1);

  redPoints=0;  bluePoints=0;

  // setup the array for mr. smiley
//  smileyInit(
//    1,    // Smiley 1
//    BLK,  // smBGColor,
//    GRN,  // smEyeWhiteColor,
//    GRN,  // smEyeColor,
//    YEL,  // smNoseColor,
//    RED,  // smMouthColor,
//    YEL); // smOutlineColor

  smileyInit(
    1,    // Smiley 1
    BLK,  // smBGColor,
    BLU,  // smEyeWhiteColor,
    BLU,  // smEyeColor,
    BLU,  // smNoseColor,
    BLU,  // smMouthColor,
    BLU); // smOutlineColor

  smileyInit(
    2,    // Smiley 2
    BLK,  // smBGColor,
    RED,  // smEyeWhiteColor,
    RED,  // smEyeColor,
    RED,  // smNoseColor,
    RED,  // smMouthColor,
    RED); // smOutlineColor

  clrMyScreen(BLK);

  // set initial X,Y coordinates
  x1PixAdr = 480; y1PixAdr = 400;
  setCurrentSmiley(1);  // Smiley 1
  placeSmiley (x1PixAdr, y1PixAdr);

  // set initial X,Y coordinates
  x2PixAdr = 160; y2PixAdr = 177;
  setCurrentSmiley(2);  // Smiley 2
  placeSmiley (x2PixAdr, y2PixAdr);

  // start the game
  //gpio_Write(GPIO_CTRL_REG, 0xffffffff);
  XGpio_mSetDataDirection(GPIO_BASEADDR, 1); // Set gpio bits to all input
  while (1)
  {
    //gpioDataRead = gpio_Read(GPIO_DATA_REG);
    gpioDataRead = XGpio_mGetDataReg(GPIO_BASEADDR);
    gpioDataRead = gpioDataRead & 0x7F7F0000;  // Clear out "unused" bits

    if (gpioDataRead & R_GAME_SW_RT)
      {
        setCurrentSmiley(1);  // Smiley 1
        detected = detectOtherSmiley(x1PixAdr, y1PixAdr);
        clearSmiley (x1PixAdr, y1PixAdr, BLK);
        if (detected == 1)
        {
          updatePoints(1);  // blue player
          x2PixAdr = 160; y2PixAdr = 177;
        }
        x1PixAdr = x1PixAdr + 1;
        if (x1PixAdr > 639)
          {
            x1PixAdr = 639;
          }
        placeSmiley (x1PixAdr, y1PixAdr);
      }

    if (gpioDataRead & R_GAME_SW_LFT)
      {
        setCurrentSmiley(1);  // Smiley 1
        detected = detectOtherSmiley(x1PixAdr, y1PixAdr);
        clearSmiley (x1PixAdr, y1PixAdr, BLK);
        if (detected == 1)
        {
          updatePoints(1);  // blue player
          x2PixAdr = 160; y2PixAdr = 177;
        }
        if (x1PixAdr > 1)
          {
            x1PixAdr = x1PixAdr - 1;
          }
        else
          {
            x1PixAdr = 0;
          }
        placeSmiley (x1PixAdr, y1PixAdr);
      }

    if (gpioDataRead & R_GAME_SW_BOT)
      {
        setCurrentSmiley(1);  // Smiley 1
        detected = detectOtherSmiley(x1PixAdr, y1PixAdr);
        clearSmiley (x1PixAdr, y1PixAdr, BLK);
        if (detected == 1)
        {
          updatePoints(1);  // blue player
          x2PixAdr = 160; y2PixAdr = 177;
        }
        y1PixAdr = y1PixAdr + 1;
        if (y1PixAdr > 479)
          {
            y1PixAdr = 479;
          }
        placeSmiley (x1PixAdr, y1PixAdr);
      }

    if (gpioDataRead & R_GAME_SW_TOP)
      {
        setCurrentSmiley(1);  // Smiley 1
        detected = detectOtherSmiley(x1PixAdr, y1PixAdr);
        clearSmiley (x1PixAdr, y1PixAdr, BLK);
        if (detected == 1)
        {
          updatePoints(1);  // blue player
          x2PixAdr = 160; y2PixAdr = 177;
        }
        if (y1PixAdr > 1)
          {
            y1PixAdr = y1PixAdr - 1;
          }
        else
          {
            y1PixAdr = 0;
          }
        placeSmiley (x1PixAdr, y1PixAdr);
      }

    if (gpioDataRead & L_GAME_SW_RT)
      {
        setCurrentSmiley(2);  // Smiley 2
        detected = detectOtherSmiley(x2PixAdr, y2PixAdr);
        clearSmiley (x2PixAdr, y2PixAdr, BLK);
        if (detected == 1)
        {
          updatePoints(2);  // red player
          x1PixAdr = 480; y1PixAdr = 400;
        }
        x2PixAdr = x2PixAdr + 1;
        if (x2PixAdr > 639)
          {
            x2PixAdr = 639;
          }
        placeSmiley (x2PixAdr, y2PixAdr);
      }

    if (gpioDataRead & L_GAME_SW_LFT)
      {
        setCurrentSmiley(2);  // Smiley 2
        detected = detectOtherSmiley(x2PixAdr, y2PixAdr);
        clearSmiley (x2PixAdr, y2PixAdr, BLK);
        if (detected == 1)
        {
          updatePoints(2);  // red player
          x1PixAdr = 480; y1PixAdr = 400;
        }
        if (x2PixAdr > 1)
          {
            x2PixAdr = x2PixAdr - 1;
          }
        else
          {
            x2PixAdr = 0;
          }
        placeSmiley (x2PixAdr, y2PixAdr);
      }

    if (gpioDataRead & L_GAME_SW_BOT)
      {
        setCurrentSmiley(2);  // Smiley 2
        detected = detectOtherSmiley(x2PixAdr, y2PixAdr);
        clearSmiley (x2PixAdr, y2PixAdr, BLK);
        if (detected == 1)
        {
          updatePoints(2);  // red player
          x1PixAdr = 480; y1PixAdr = 400;
        }
        y2PixAdr = y2PixAdr + 1;
        if (y2PixAdr > 479)
          {
            y2PixAdr = 479;
          }
        placeSmiley (x2PixAdr, y2PixAdr);
      }

    if (gpioDataRead & L_GAME_SW_TOP)
      {
        setCurrentSmiley(2);  // Smiley 2
        detected = detectOtherSmiley(x2PixAdr, y2PixAdr);
        clearSmiley (x2PixAdr, y2PixAdr, BLK);
        if (detected == 1)
        {
          updatePoints(2);  // red player
          x1PixAdr = 480; y1PixAdr = 400;
        }
        if (y2PixAdr > 1)
          {
            y2PixAdr = y2PixAdr - 1;
          }
        else
          {
            y2PixAdr = 0;
          }
        placeSmiley (x2PixAdr, y2PixAdr);
      }

    setCurrentSmiley(1);  // Smiley 1
    placeSmiley (x1PixAdr, y1PixAdr);
    setCurrentSmiley(2);  // Smiley 2
    placeSmiley (x2PixAdr, y2PixAdr);

    if (AbortByKeyboard()) break;

    XromLedToggle();

  }

  XromLogLn();
  XromLogString("FINAL SCORE:  ");
  XromLogString("Blue Points = ");
  XromLogInt(bluePoints);
  XromLogString(", Red Points =");
  XromLogInt(redPoints);
  XromLogLn();

  XromLogString("THANKS FOR PLAYING!  Press any key to go back to Test menu\r\n");
  return;
}
