/*-----------------------------------------------------------------------------
//     $Date: 2004/03/10 23:35:36 $
//     $RCSfile: xromtestbutton.c,v $
//-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "globaltypes.h"
#include "xromtestram.h"
#include "xromsmiley.h"
#include "xromlog.h"
#include "xromled.h"
#include "xromabort.h"
#include "xgpio_l.h"
#include "xparameters.h"
#include "sleep.h"

#define memsize 128*1024*1024
// #define note   // prints general notes of where you are in code
// #define note2  // prints status during inner loop of 16 word inverse noise cycles
#define ddr_memory_ml3
// #define ddr_memory_ml2
// define switches
#define ml3

#define GPIO_BASEADDR XPAR_MY_OPB_GPIO_0_BASEADDR_0

  // Test the Buttons

void XromTestPBs ( )
  {
  unsigned long dataRead;

  XromLogString("Press the Esc key to exit, or other buttons to verify those buttons work\r\n");
  while (1)
  {
    //dataRead = gpio_Read(GPIO_DATA_REG);
    dataRead = XGpio_mGetDataReg(GPIO_BASEADDR);
    dataRead = dataRead & 0x7F7F0000;  // Clear out "unused" bits
    switch (dataRead)
     {
      case R_BOT_SW:
        XromLogString("R_BOT_SW      pressed\r\n");
        break;
      case R_MID_SW:
        XromLogString("R_MID_SW      pressed\r\n");
        break;
      case R_TOP_SW:
        XromLogString("R_TOP_SW      pressed\r\n");
        break;
      case R_GAME_SW_TOP:
        XromLogString("R_GAME_SW_TOP pressed\r\n");
        break;
      case R_GAME_SW_LFT:
        XromLogString("R_GAME_SW_LFT pressed\r\n");
        break;
      case R_GAME_SW_RT:
        XromLogString("R_GAME_SW_RT  pressed\r\n");
        break;
      case R_GAME_SW_BOT:
        XromLogString("R_GAME_SW_BOT pressed\r\n");
        break;
      case L_BOT_SW:
        XromLogString("L_BOT_SW      pressed\r\n");
        break;
      case L_MID_SW:
        XromLogString("L_MID_SW      pressed\r\n");
        break;
      case L_TOP_SW:
        XromLogString("L_TOP_SW      pressed\r\n");
        break;
      case L_GAME_SW_TOP:
        XromLogString("L_GAME_SW_TOP pressed\r\n");
        break;
      case L_GAME_SW_LFT:
        XromLogString("L_GAME_SW_LFT pressed\r\n");
        break;
      case L_GAME_SW_RT:
        XromLogString("L_GAME_SW_RT  pressed\r\n");
        break;
      case L_GAME_SW_BOT:
        XromLogString("L_GAME_SW_BOT pressed\r\n");
        break;
     }
    XromLedToggle();
    if (AbortByKeyboard()) break;
  }
  return;
}



