/*-----------------------------------------------------------------------------
//     $Date: 2004/03/10 23:35:36 $
//     $RCSfile: xromtouchscreen.c,v $
//-----------------------------------------------------------------------------
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "xbasic_types.h"
#include "xromlog.h"
#include "xromtouchscreen.h"
#include "xtouchscreen.h"
#include "xromabort.h"
#include "xromled.h"
#include "xparameters.h"
#include "sleep.h"

#define TOUCHSCREEN_DEVICE_ID      XPAR_OPB_TSD_REF_0_DEVICE_ID

#define NORM_FACTOR      1000000
/* values generated by touchcalibrate */
#define DEFAULT_XMULT    956
#define DEFAULT_YMULT    1192
#define DEFAULT_XLCORN   254057
#define DEFAULT_YLCORN   197499

static XTouchscreen Touchscreen;

void XromTouchscreenInit(void)
{
  XTouchscreen_Initialize(&Touchscreen, TOUCHSCREEN_DEVICE_ID);
  usleep(100);
}

void XromTestTouchscreen(void)
{
  Xuint32 x, y, z;
  Xuint32 ctrlReg;

  XromLogString("  Touchscreen - press ESC to abort\r\n");

  do
  {
    //touchscreen_Select(TOUCHSCREEN_BASEADDR, &readmask, &writemask, &excpmask);
    ctrlReg = XTouchscreen_mReadCtrlReg(Touchscreen.BaseAddress);
    // if touchscreen is touched
    if (ctrlReg & 0x1)
    {
      XTouchscreen_GetPosition_3D(&Touchscreen, &x, &y, &z);
      // normalize values
      x = NORM_FACTOR - ((x * NORM_FACTOR) / 0x1000);
      y = (y * NORM_FACTOR) / 0x1000;
      // signed computation
      x = (x - DEFAULT_XLCORN+(16*DEFAULT_XMULT)) / DEFAULT_XMULT;
      y = (y - DEFAULT_YLCORN+(16*DEFAULT_YMULT)) / DEFAULT_YMULT;

      XromLogString("(x, y) = ");
      XromLogInt(x);
      XromLogString(", ");
      XromLogInt(y);
      XromLogLn();
    }
    XromLedToggle();
  } while (!AbortByKeyboard());
}


